package com.engine.organization.thread;

import com.engine.organization.entity.cusfielddata.po.CusFieldData;
import com.engine.organization.entity.map.JclOrgMap;
import com.engine.organization.mapper.jclorgmap.JclOrgMapper;
import com.engine.organization.mapper.trigger.CompTriggerMapper;
import com.engine.organization.mapper.trigger.HrmResourceTriggerMapper;
import com.engine.organization.util.OrganizationDateUtil;
import com.engine.organization.util.db.MapperProxyFactory;
import org.apache.commons.lang.StringUtils;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.hrm.passwordprotection.domain.HrmResource;

import java.sql.Date;
import java.util.Calendar;

/**
 * @author:dxfeng
 * @createTime: 2022/09/01
 * @version: 1.0
 */
public class HrmResourceTriggerRunnable implements Runnable {
    Long userId;

    private CompTriggerMapper getCompTriggerMapper() {
        return MapperProxyFactory.getProxy(CompTriggerMapper.class);
    }

    private HrmResourceTriggerMapper getHrmResourceTriggerMapper() {
        return MapperProxyFactory.getProxy(HrmResourceTriggerMapper.class);
    }

    private JclOrgMapper getJclOrgMapper() {
        return MapperProxyFactory.getProxy(JclOrgMapper.class);
    }

    public HrmResourceTriggerRunnable(Long id) {
        this.userId = id;
    }

    @Override
    public void run() {
        int st = 100000000;
        int sj = 200000000;
        int sk = 300000000;
        Integer delete = null;
        JclOrgMap jclMap = new JclOrgMap();
        jclMap.setFType(4);
        // 当前日期  yyyy-MM-dd
        String currentDate = OrganizationDateUtil.getFormatLocalDate(new java.util.Date());

        // 查询当前人员信息数据
        HrmResource hrmResource = getHrmResourceTriggerMapper().getHrmResource(userId);
        if (null != hrmResource) {
            jclMap.setFObjId(hrmResource.getId());
            jclMap.setId(hrmResource.getId() + sk);
            jclMap.setFNumber(hrmResource.getWorkcode());
            jclMap.setFName(hrmResource.getLastname());
            delete = hrmResource.getStatus() <= 3 ? 0 : 1;
            jclMap.setFLeaderImg(hrmResource.getMessagerurl());
            // 更新组织架构图，组织架构负责人头像
            RecordSet rs = new RecordSet();
            rs.executeUpdate("update jcl_org_map set fleaderimg = ? where fleader =? and fdateend > ?", hrmResource.getMessagerurl(), hrmResource.getId(), currentDate);
            jclMap.setFLeaderName(hrmResource.getLastname());
            jclMap.setFLeaderJobId(hrmResource.getJobtitle());
            String field100002 = getHrmResourceTriggerMapper().getField100002(jclMap.getFObjId());
            if (StringUtils.isNotBlank(field100002)) {
                jclMap.setFObjParentId(Integer.parseInt(field100002));
                jclMap.setFParentId(jclMap.getFObjParentId() + sj);
            }
            CusFieldData cusFieldDataById = getHrmResourceTriggerMapper().getCusFieldDataById(jclMap.getFObjId());
            if (null != cusFieldDataById) {
                jclMap.setFLeaderSt(cusFieldDataById.getField100008());
                jclMap.setFLeaderLv(cusFieldDataById.getField100007());
            }
            jclMap.setFClass(0);
            jclMap.setFClassName("行政维度");
            jclMap.setFLeaderJob(getCompTriggerMapper().getJobTitleMarkById(jclMap.getFLeaderJobId()));
            jclMap.setFDateBegin(new Date(OrganizationDateUtil.stringToDate(currentDate).getTime()));
            jclMap.setFDateEnd(new Date(OrganizationDateUtil.stringToDate("2099-12-31").getTime()));
            jclMap.setFIsVitual(0);

            Calendar cal = Calendar.getInstance();
            cal.setTime(jclMap.getFDateBegin());
            Calendar calendar = DateUtil.addDay(cal, -1);
            Date time = new Date(calendar.getTime().getTime());
            // 更新前的数据
            JclOrgMap jclOrgMapByObjID = getJclOrgMapper().getJclOrgMapByObjID(jclMap.getFDateBegin(), "4", hrmResource.getId().toString());

            getCompTriggerMapper().deleteMap(jclMap.getFType(), jclMap.getFObjId(), jclMap.getFDateBegin());
            getCompTriggerMapper().updateMap(jclMap.getFType(), jclMap.getFObjId(), jclMap.getFDateBegin(), time);
            if (0 == delete) {
                MapperProxyFactory.getProxy(JclOrgMapper.class).insertMap(jclMap);
                // 更新当前架构图负责人的卡片信息
                getHrmResourceTriggerMapper().updateLeaders(jclMap.getFDateBegin(), hrmResource.getId().toString(), jclMap.getFLeaderImg(), jclMap.getFLeaderName(), jclMap.getFLeaderJobId(), jclMap.getFLeaderJob(), jclMap.getFLeaderLv(), jclMap.getFLeaderSt());
                // 更新组织架构图在岗数
                if (null != jclOrgMapByObjID) {
                    new StaffTriggerRunnable(jclOrgMapByObjID.getFObjParentId()).run();
                }
                new StaffTriggerRunnable(jclMap.getFObjParentId()).run();

            } else if (null != jclOrgMapByObjID) {
                new StaffTriggerRunnable(jclOrgMapByObjID.getFObjParentId()).run();
            }
        }
    }
}
